#-*- coding: utf-8 -*-

import wxversion
wxversion.select('2.8')
import wx,sys

from pandac.PandaModules import *
from direct.showbase import DirectObject
import basecom

class SampleWxFrame (basecom.BaseComponent):
    
    def __init__(self):
        basecom.BaseComponent.__init__(self)
        self.name = "Sample wx frame"
        self.version = "0.11"
    def before_direct_import(self):
        loadPrcFileData("", "window-type none")
    def after_direct_import(self):
        self.frame = EditorApp()
        

class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.notebook_1 = wx.Notebook(self, -1, style=0)
        self.panel_1 = P3dViewport(self, -1)
        self.notebook_1_pane_1 = wx.Panel(self.notebook_1, -1)
        
        # Tool Bar
        self.frame_1_toolbar = wx.ToolBar(self, -1)
        self.SetToolBar(self.frame_1_toolbar)
        # Tool Bar end
        self.frame_1_statusbar = self.CreateStatusBar(1, 0)
        
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        self.mFile = wx.Menu()
        self.mExit = wx.MenuItem(self.mFile, wx.NewId(), "Exit", "", wx.ITEM_NORMAL)
        self.mFile.AppendItem(self.mExit)
        self.frame_1_menubar.Append(self.mFile, "File")
        self.SetMenuBar(self.frame_1_menubar)
        # Menu Bar end

        self.__set_properties()
        self.__do_layout()
        # end wxGlade
        self.Bind(wx.EVT_MENU, self.exitProgram, self.mExit)
        self.Bind(wx.EVT_CLOSE, self.onCloseWindow)

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("frame_1")
        #self.SetSize((848, 661))
        self.frame_1_toolbar.Realize()
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = ["frame_1_statusbar"]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add(self.panel_1, 3, wx.EXPAND, 0)
        self.notebook_1.AddPage(self.notebook_1_pane_1, "tab1")
        sizer_2.Add(self.notebook_1, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_2)
        sizer_2.SetSizeHints(self)
        self.SetSize((848, 661))
        self.Layout()
        # end wxGlade
        
    def exitProgram(self, event): # wxGlade: MainFrame.<event_handler>
        self.Close();
        sys.exit();  
        
    def onCloseWindow(self,event):
        sys.exit();
        
        
class P3dViewport(wx.Panel):
  # this panel contains the panda 3d window
  def __init__(self, *args, **kwargs):
    wx.Panel.__init__(self, *args, **kwargs)

  def initialize(self):
    # the panda3d window must be put into the panel after the wx-window has
    # been created
    assert self.GetHandle() != 0

    # put the panda3d
    wp = WindowProperties()
    wp.setOrigin(0, 0)
    wp.setSize(self.ClientSize.GetWidth(), self.ClientSize.GetHeight())
    wp.setParentWindow(self.GetHandle())
    base.openDefaultWindow(props = wp, gsg = None)

    # attach the resize event
    wx.EVT_SIZE(self, self.OnResize)

  def OnResize(self, event):
    # when the wx-panel is resized, fit the panda3d window into it
    frame_size = event.GetSize()
    wp = WindowProperties()
    wp.setOrigin(0, 0)
    wp.setSize(frame_size.GetWidth(), frame_size.GetHeight())
    base.win.requestProperties(wp)
    

class EditorApp(DirectObject.DirectObject):
  def __init__(self):

    self.wxApp = wx.App(redirect = False)
    self.wxApp.SetAppName("Panda Editor")
    self.wxApp.SetClassName("PEditor")

    self.appInit()
    self.MainWindow = MyFrame(None, -1, "")
    self.wxApp.SetTopWindow(self.MainWindow)
    self.MainWindow.Show() 
    
    # update the wx-window and run a step (window created?)
    self.MainWindow.Update()
    self.wxStep()
    # update the p3d window
    self.MainWindow.panel_1.initialize()

    # do something with the panda3d view
    loader.loadModel('environment').reparentTo(render)



  def appInit(self):
    # Create a new event loop (to overide default wxEventLoop)
    self.evtLoop = wx.EventLoop()
    self.oldLoop = wx.EventLoop.GetActive()
    wx.EventLoop.SetActive(self.evtLoop)
    taskMgr.add(self.wxStep, "evtLoopTask")

  def onDestroy(self, evt):
    # called on wx window destroy
    wx.EventLoop.SetActive(self.oldLoop)
   
  def quit(self,event):
    self.onDestroy(event)
      # to close Panda
    try:
      base
    except NameError:
      sys.exit()       
    base.userExit()

  def wxStep(self, task = None):
    # process the events wx sends
    while self.evtLoop.Pending():
      self.evtLoop.Dispatch()
    self.wxApp.ProcessIdle()
    if task != None: return task.cont
    
